'Copyright (c) 2005-2009, 2012 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Collections.Specialized

Public Class skillDict

    Private prv_AOInternalID_To_AOSName_Dict As New StringDictionary
    Private prv_AOInternalID_To_AOSID_Dict As New StringDictionary
    Private prv_AOInternalName_To_AOInternalID_Dict As New StringDictionary
    Private prv_AOClusterName_To_AOInternalName_Dict As New StringDictionary
    Private prv_AOSID_To_AOInternalID_Dict As New StringDictionary
    Private prv_AOSName_To_AOSID_Dict As New StringDictionary

    Public Sub AddSkill(ByVal p_AOS_ID As Integer, ByRef p_AOS_Skill_Name As String, ByVal p_AO_Internal_ID As Integer, ByRef p_AO_Internal_Name As String, ByRef p_AO_Cluster_Name As String)
        prv_AOInternalID_To_AOSName_Dict.Add(p_AO_Internal_ID.ToString(), p_AOS_Skill_Name)
        prv_AOInternalID_To_AOSID_Dict.Add(p_AO_Internal_ID.toString(), p_AOS_ID.toString())
        prv_AOInternalName_To_AOInternalID_Dict.Add(p_AO_Internal_Name, p_AO_Internal_ID.toString())
        prv_AOClusterName_To_AOInternalName_Dict.Add(p_AO_Cluster_Name, p_AO_Internal_Name)
        prv_AOSID_To_AOInternalID_Dict.Add(p_AOS_ID.ToString(), p_AO_Internal_ID.ToString())
        prv_AOSName_To_AOSID_Dict.Add(p_AOS_Skill_Name, p_AOS_ID.ToString())
    End Sub

    Public Function Find_AOSName_From_AOInternalID(ByVal p_AO_Interal_ID As Integer) As String
        Return prv_AOInternalID_To_AOSName_Dict.Item(p_AO_Interal_ID.ToString())
    End Function

    Public Function Find_AOSID_From_AOInternalID(ByVal p_AO_Interal_ID As Integer) As Integer
        Return CType(prv_AOInternalID_To_AOSID_Dict.Item(p_AO_Interal_ID.ToString()), Integer)
    End Function

    Public Function Find_AOInternalID_From_AOInternalName(ByVal p_AO_Internal_Name As String) As Integer
        Return CType(prv_AOInternalName_To_AOInternalID_Dict.Item(p_AO_Internal_Name), Integer)
    End Function

    Public Function Find_AOInternalName_From_AOClusterName(ByVal p_AO_Cluster_Name As String) As String
        Return prv_AOClusterName_To_AOInternalName_Dict.Item(p_AO_Cluster_Name)
    End Function

    Public Function Find_AOInternalID_From_AOSID(ByVal p_AOS_ID As Integer) As Integer
        Return CType(prv_AOSID_To_AOInternalID_Dict.Item(p_AOS_ID.ToString()), Integer)
    End Function

    Public Function Find_AOSID_From_AOSName(ByVal p_AOSName As String) As Integer
        Return CType(prv_AOSName_To_AOSID_Dict.Item(p_AOSName), Integer)
    End Function

End Class
