'Copyright (c) 2008-2012 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Collections
Imports Microsoft.VisualBasic
Imports System.Xml

Module modAlienEye

    Public Const EOE_LO_AOID As Integer = 252986
    Public Const EOE_HI_AOID As Integer = 252987

    ' These have multiple skills (like symbiants) but variable QL (like implants)

    ' Adventurer, Agent, Bureaucrat, Engineer, Fixer, Soldier, Trader
    Private profsExterminatorOccularEnhancement() As Integer = { _
        0, 1, 2, 5, 6, 12, 13 _
    }


    Public Function checkProfAlienEye(ByVal prof_id As Integer) As Boolean
        Dim i As Integer

        For i = 0 To profsExterminatorOccularEnhancement.Length - 1
            If prof_id = profsExterminatorOccularEnhancement(i) Then
                Return True
            End If
        Next
        Return False
    End Function

    Function getAlienEyeTooltip(ByVal ql As Integer) As String
        Dim s As String
        Dim j As Integer
        Dim tmpMods(NUM_SKILLS + NUM_ATTRS + 1) As Integer

        getItemModifiers(EOE_LO_AOID, EOE_HI_AOID, ql, tmpMods)
        For j = 0 To NUM_SKILLS - 1
            If tmpMods(j) <> 0 Then
                s &= "#" & skillNames(j) & " : " & tmpMods(j)
            End If
        Next
        For j = 0 To NUM_ATTRS - 1
            If tmpMods(j) <> 0 Then
                s &= "#" & attrNames(j) & " : " & tmpMods(j + NUM_SKILLS)
            End If
        Next
        If tmpMods(NUM_SKILLS + NUM_ATTRS) <> 0 Then
            s &= "#" & "Max Health" & " : " & tmpMods(j + NUM_SKILLS)
        End If
        If tmpMods(NUM_SKILLS + NUM_ATTRS + 1) <> 0 Then
            s &= "#" & "Max Nano" & " : " & tmpMods(j + NUM_SKILLS)
        End If
        s = s.Substring(1)
        s = s.Replace("#", Chr(10))
        Return s
    End Function


End Module
