'Copyright (c) 2003-2013 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports Microsoft.VisualBasic

Module modMain

    Public fmMain As frmMain
    Public fmBuff As frmBuffs
    Public fmBene As frmBenefits
    Public fmPDoll As frmPaperDoll
    Public fmImplant As frmImplants

    Public attrCA As nudArray
    Public skillsCA As nudArray
    Public hpCA As aoskillControl2
    Public npCA As aoskillControl2

    Public noRecalc As Boolean = False
    Public loadingData As Boolean = False

    Public numPerkCheckboxes As Integer = 0
    Public numAIPerkCheckboxes As Integer = 0
    Public numResearchCheckboxes As Integer = 0

    Public perkCA As chkArray
    Public aiperkCA As chkArrayAI
    Public researchCA As chkArrayLE

    Public strEquipData As String = ""
    Public strImplantData As String = ""

    Public home_dir As String

    Public impA As impArray
    Public Const MAX_IMPS As Integer = 12

    Public hasChanges As Boolean

    Public Sub Main()
        Try
            home_dir = CurDir()
            initSkillDict(objSkillDict)
            impA = New impArray
            ' create instances of all forms
            fmBuff = New frmBuffs
            fmBene = New frmBenefits
            fmPDoll = New frmPaperDoll
            fmImplant = New frmImplants
            fmMain = New frmMain
            ' attempt to open the item database
            db_conn = openDB(home_dir)
            If IsNothing(db_conn) Then
                MsgBox("Unable to open AOIA item database.", MsgBoxStyle.Critical, "AOSkills3")
                End
            End If
            ' initialise equipment form icons
            fmPDoll.initPBArray()
            ' ensure database has AOS implant table
            fmImplant.initTableIfRequired()
            ' show main form
            fmMain.ShowDialog()
        Catch e As Exception
            MsgBox(e.Message, CType(MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, Microsoft.VisualBasic.MsgBoxStyle), "AOSkills3 Exception")
        End Try
    End Sub

    Public Sub ResetChar()
        Dim i As Integer

        noRecalc = True
        fmMain.nudLevel.Value = 1
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Improvement = 0
            skillsCA.Item(i).IPLeft = 1500
        Next
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Improvement = 0
            attrCA.Item(i).IPLeft = 1500
        Next
        resetEquipment()
        ClearPerks()
        ClearMisc()
        fmBuff.ClearBuffs()
        noRecalc = False
        recalcIP()
        hasChanges = False
    End Sub

    Public Sub loadWinSize()
        Dim sr As System.IO.StreamReader = New System.IO.StreamReader("windows.ini")
        Dim ln As String
        Try
            ln = sr.ReadLine()
            fmMain.Width = CInt(ln.Split(Chr(61))(1))
            ln = sr.ReadLine()
            fmMain.Height = CInt(ln.Split(Chr(61))(1))
            ln = sr.ReadLine()
            fmPDoll.chkReqs.Checked = CBool(ln.Split(Chr(61))(1))
            ln = sr.ReadLine()
            fmImplant.chkReqs.Checked = CBool(ln.Split(Chr(61))(1))
            ln = sr.ReadLine()
            fmMain.Left = CInt(ln.Split(Chr(61))(1))
            ln = sr.ReadLine()
            fmMain.Top = CInt(ln.Split(Chr(61))(1))
        Catch e As Exception
            ' do nothing, but will ensure we just skip over missing lines
        End Try
        sr.Close()
    End Sub

    Public Sub saveWinSize()
        Dim sw As System.IO.StreamWriter = New System.IO.StreamWriter("windows.ini")
        sw.WriteLine("MainW=" & fmMain.Width)
        sw.WriteLine("MainH=" & fmMain.Height)
        sw.WriteLine("EquipCR=" & fmPDoll.chkReqs.Checked)
        sw.WriteLine("ImpCR=" & fmImplant.chkReqs.Checked)
        sw.WriteLine("MainX=" & fmMain.Left)
        sw.WriteLine("MainY=" & fmMain.Top)
        sw.Close()
    End Sub

End Module
